'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5205] on 10 May 2003 at 4:06:20 pm'!
"Change Set:		RefactorSMLoader-bkv
Date:			10 May 2003
Author:			Brent Vukmer

Some minor edits of SMLoader; the BugFixArchiveViewer is nothing but a shameless imitation of SMLoader, to the point of subclassing directly from it."!


!SMLoader methodsFor: 'lists' stamp: 'bkv 5/9/2003 13:04'!
addFilter: aFilterArray toMenu: aMenu
	| filterSymbol help |

	filterSymbol _ aFilterArray second.
    help _ aFilterArray third.
	aMenu addUpdating: #showFilterString: target: self selector: #toggleFilterState: argumentList: (Array with: filterSymbol).
	aMenu balloonTextForLastItem: help

	! !

!SMLoader methodsFor: 'lists' stamp: 'bkv 5/9/2003 13:04'!
addFiltersToMenu: aMenu

	self filterSpecs do: [:filterArray | self addFilter: filterArray toMenu: aMenu ]

	! !

!SMLoader methodsFor: 'gui building' stamp: 'bkv 5/9/2003 13:40'!
createWindow
	self addMorph: (self buildMorphicPackagesList borderWidth: 0)
		frame: (0 @ 0 corner: 0.4 @ 1).
	self addMorph: (self buildPackagePane borderWidth: 0)
		frame: (0.4 @ 0 corner: 1.0 @ 1.0).
	self 
		on: #mouseEnter
		send: #paneTransition:
		to: self.
	self 
		on: #mouseLeave
		send: #paneTransition:
		to: self.
	self setUpdatablePanesFrom: self defaultUpdatablePaneSelectors.
	self setLabel: self windowLabel! !

!SMLoader methodsFor: 'gui building' stamp: 'bkv 5/9/2003 13:39'!
defaultUpdatablePaneSelectors

  ^ #(#packageNameList #selectedPackagesList).
! !

!SMLoader methodsFor: 'gui building' stamp: 'bkv 5/9/2003 13:40'!
windowLabel

  ^'SM Package Loader'! !

!SMLoader methodsFor: 'model' stamp: 'bkv 5/9/2003 11:25'!
loadUpdates
	self model loadUpdates.
	self noteChanged ! !

!SMLoader methodsFor: 'model' stamp: 'bkv 5/9/2003 11:28'!
on: aSqueakMap 
	self model: aSqueakMap.
	self loadUpdates.
	downloadDirectory := FileDirectory default.
	filter := OrderedCollection new.
	"Initial configuration -"
	self defaultFilters do: [ :selector | self filterAdd: selector ].
! !

!SMLoader methodsFor: 'model' stamp: 'bkv 5/9/2003 11:26'!
packages
	"We request the cards as sorted by name by default."

	^self model cardsByName asArray
! !

!SMLoader methodsFor: 'model' stamp: 'bkv 5/9/2003 11:27'!
upgradeInstalledPackages
	self model upgradeOldPackagesDirectory: downloadDirectory.
	self noteChanged! !

!SMLoader methodsFor: 'filters' stamp: 'bkv 5/9/2003 11:29'!
defaultFilters

^{
 #filterAutoInstall.
    #filterNotUptoDate.
    #filterVersion. }! !


!SMLoader class methodsFor: 'menu registration' stamp: 'bkv 5/9/2003 11:32'!
initialize
	
	 (TheWorldMenu respondsTo: #registerOpenCommand:)
         ifTrue: [TheWorldMenu registerOpenCommand: { self menuRegistrationKey. {self. #open}}].
! !

!SMLoader class methodsFor: 'menu registration' stamp: 'bkv 5/9/2003 11:31'!
menuRegistrationKey

^'Package Loader'
! !

!SMLoader class methodsFor: 'menu registration' stamp: 'bkv 5/9/2003 11:32'!
removeFromSystem

		self unload.
		super removeFromSystem.! !

!SMLoader class methodsFor: 'menu registration' stamp: 'bkv 5/9/2003 11:32'!
unload

		(TheWorldMenu respondsTo: #registerOpenCommand:) ifTrue: 
			[TheWorldMenu unregisterOpenCommand:  self menuRegistrationKey ].! !

SMLoader initialize!

!SMLoader class reorganize!
('menu registration' initialize menuRegistrationKey removeFromSystem unload)
('instance creation' new newOn: open openOn:)
!

